'\" t
.\"	plasticfs - the plastic file system
.\"	Copyright (C) 2003 Peter Miller;
.\"	All rights reserved.
.\"
.\"	This program is free software; you can redistribute it and/or modify
.\"	it under the terms of the GNU General Public License as published by
.\"	the Free Software Foundation; either version 2 of the License, or
.\"	(at your option) any later version.
.\"
.\"	This program is distributed in the hope that it will be useful,
.\"	but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"	GNU General Public License for more details.
.\"
.\"	You should have received a copy of the GNU General Public License
.\"	along with this program; if not, write to the Free Software
.\"	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
.\"
.\" MANIFEST: manual entry for the plasticfs_chroot.l command
.\"
.ds n) plasticfs_chroot.l
.TH \*(n) 1 PlasticFS "Reference Manual"
.SH NAME
plasticfs_chroot \- change the root of the file system
.XX "plasticfs_chroot(l)" "change the root of the file system"
.SH SYNOPSIS
\f[CW]PLASTICFS="chroot /\fP\fIdirectory\fP\f[CW]"\fP
.SH DESCRIPTION
The PlasticFS \fIchroot\fP filter is used to
change the aparrent root of the file system.
.SH EXAMPLE
To construct what appears to be a user-writable simulation of the entire
file system, make a suitable directory and then use the \f[CW]viewpath\fP
filter to place it "in front of" the whole file system, and then use
\f[CW]chroot\fP to make this view path appear to actually be the whole
file system.
This may be achieved as follows:
.RS
.ft CW
.nf
mkdir /tmp/\fIexample\fP
cd /tmp/\fIexample\fP
PLASTICFS="chroot /tmp/\fIexample\fP | \e
viewpath /tmp/\fIexample\fP /" \e
LD_PRELOAD=libplasticfs.so \e
bash
.fi
.ft R
.RE
You should now be able to \fIcd\fP to an open sourec package you wish
to install, and issue the
.RS
\f[CW]\make install\fP
.RE
command.  All effect will actually be realized in the directory tree
below \f[CW]/tmp/\fP\fIexample\fP, and it's not necessary to be \fIroot\fP
during the install.
.SH SECURITY
PlasticFS does nothing at all of the executing user is root, or if the
program is set-uid or set-gid.  This is for security reasons.
.PP
Imagine, in our above example, the \fI/etc/passwd\fP file was edited
to give \f[CW]root\fP no password
(remember, the whole file system is now writable) and then the \fIsu\fP(8)
program is used.  If PlasticFS permitted \fIsu\fP(8) to
run with the simulated file system, it would completely compromse the
security of the whole system.
.PP
This would be bad.  PlasticFS presents the real file sytem in situations
which in any way could involve system security.
.so ../man3/z_copyright.so
