'\" t
.\"	plasticfs - the plastic file system
.\"	Copyright (C) 2003 Peter Miller;
.\"	All rights reserved.
.\"
.\"	This program is free software; you can redistribute it and/or modify
.\"	it under the terms of the GNU General Public License as published by
.\"	the Free Software Foundation; either version 2 of the License, or
.\"	(at your option) any later version.
.\"
.\"	This program is distributed in the hope that it will be useful,
.\"	but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"	GNU General Public License for more details.
.\"
.\"	You should have received a copy of the GNU General Public License
.\"	along with this program; if not, write to the Free Software
.\"	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
.\"
.\" MANIFEST: manual entry for the plasticfs_viewpath.l command
.\"
.ds n) plasticfs_viewpath.l
.TH \*(n) 1 PlasticFS "Reference Manual"
.SH NAME
plasticfs_viewpath \- viewpath union file system
.XX "plasticfs_viewpath(l)" "viewpath union file system"
.SH SYNOPSIS
\f[CW]PLASTICFS="viewpath\fP \fIdir1\fP \fIdir2\fP\f[CW]"\fP
.SH DESCRIPTION
The PlasticFS \fIviewpath\fP filter is used to
present the union of a set of directory trees as a single directory tree.
.PP
If files are to be modified, the first directory tree specified must be
writable; all subsequent directories may be read-only.
.PP
Accesses to files in the first directory (\fIdir1\fP) are searched for
in all of the directories specified.  Files are created in the first
directory only, and files being modified are copied into the first
directory (if necessary) before the file is opened for writing.
.PP
Directory listings are assembled from the directory contents of the
corresponding directory in each of the directory trees.  Duplicates are
suppressed.
.PP
If a file is removed from the view, and it appears later in the view path
than the first directory (\fIdir1\fP), it is added to a \fIwhiteout\fP
file, and the file effectively disappears.  The true file is not affected;
this is because \fIall\fP modifications \fIonly\fP occur in the first
directory (\fIdir1\fP) and later directories are treated as read-only.
.SS Removed Files
When a file is unlinked, its name is added to the \f[CW].whiteout\fP
file (at the top level, deeper \f[CW].whiteout\fP files are ignored).
It's a simple text file containing one filename per line.  Each directory
has one (if needed).  Some jiggery-pokery is required to supress the
names of unlinked files returned by \fIgetdirentries\fP(3), but since
we needed jiggery-pokery to suppress duplicates anyway, it is actually
very little extra code.  When a file is created, its name is removed
from the \f[CW].whiteout\fP file.
.PP
I'm told this is the way the BSD union filesystem works, too.
.PP
Removing the \f[CW].whiteout\fP file is usually a bad idea, because
removed files from further along the viewpath will mysteriously reappear.
.so ../man3/z_copyright.so
